<?php

namespace App\Forms\Part;

class IPForm extends PartForm
{
  public function __construct()
  {
    parent::__construct();
  }
  public function action_init_process(string $action, array $formDatas = []): void
  {
    $fields = [
      "lineinfo_uid",
      "ip",
      "price",
    ];
    $filters = [
      'old_clientinfo_uid',
      'clientinfo_uid',
      'serverinfo_uid',
      "lineinfo_uid",
      'status'
    ];
    $indexFilter     = $filters;
    $batchjobFilters = ['status'];
    $actionButtons = ['view' => ICONS['SEARCH']];
    $batchjobButtons = ['batchjob' => '일괄처리'];
    switch ($action) {
      case 'create':
      case 'create_form':
      case 'modify':
      case 'modify_form':
        $fields = [...$fields, 'status'];
        break;
      case 'view':
        $fields = [
          ...$fields,
          'clientinfo_uid',
          'serverinfo_uid',
          'old_clientinfo_uid',
          'status',
          'created_at'
        ];
        break;
      case 'index':
      case 'download':
        $fields = [
          ...$fields,
          'clientinfo_uid',
          'serverinfo_uid',
          'old_clientinfo_uid',
          'status',
          'created_at'
        ];
        break;
    }
    $this->setFormFields($fields);
    $this->setFormRules($action, $fields);
    $this->setFormFilters($filters);
    $this->setFormOptions($action, $filters, $formDatas);
    $this->setIndexFilters($indexFilter);
    $this->setBatchjobFilters($batchjobFilters);
    $this->setActionButtons($actionButtons);
    $this->setBatchjobButtons($batchjobButtons);
  }
  public function getFormRule(string $action, string $field, array $formRules): array
  {
    switch ($field) {
      case "lineinfo_uid":
        $formRules[$field] = "required|numeric";
        break;
      case "old_clientinfo_uid":
      case "clientinfo_uid":
      case "serviceinfo_uid":
      case "serverinfo_uid":
        $formRules[$field] = "permit_empty|numeric";
        break;
      case "ip": //ipv4 , ipv6 , both(ipv4,ipv6)
        $formRules[$field] = sprintf("required|trim|valid_ip[both]%s", in_array($action, ["create", "create_form"]) ? "|is_unique[{$this->getAttribute('table')}.{$field}]" : "");
        break;
      case "status":
        $formRules[$field] = "required|trim|string";
        break;
      default:
        $formRules =  parent::getFormRule($action, $field, $formRules);
        break;
    }
    return $formRules;
  }
  public function getFormOption(string $action, string $field, array $formDatas = [], array $options = ['options' => [], 'atttributes' => []]): array
  {
    $tempOptions = ['' => lang("{$this->getAttribute('class_path')}.label.{$field}") . " 선택"];
    switch ($field) {
      case 'lineinfo_uid':
        foreach ($this->getFormOption_process(service('equipment_lineservice'), $action, $field, $formDatas) as $tempEntity) {
          $tempOptions[$tempEntity->getPK()] = $tempEntity->getTitle();
          // $options['attributes'][$tempEntity->getPK()] = ['data-role' => implode(DEFAULTS['DELIMITER_ROLE'], $tempEntity->getRole())];
        }
        $options['options'] = $tempOptions;
        break;
      case 'old_clientinfo_uid':
        foreach ($this->getFormOption_process(service('customer_clientservice'), $action, $field, $formDatas) as $tempEntity) {
          $tempOptions[$tempEntity->getPK()] = $tempEntity->getTitle();
          // $options['attributes'][$tempEntity->getPK()] = ['data-role' => implode(DEFAULTS['DELIMITER_ROLE'], $tempEntity->getRole())];
        }
        // dd($tempOptions);
        $options['options'] = $tempOptions;
        break;
      default:
        $options = parent::getFormOption($action, $field, $formDatas, $options);
        break;
    }
    return $options;
  }
}
